/* Justin Fiedler
 * Binary image operations
 */

#ifndef _BINARY_
#define _BINARY_

#include <math.h>
#include "libtarga.h"
#include "TargaImage.h"

/* filters MUST be of odd width/height */

class BinaryFilter{
public:
	int width, height;
	int * filter_data;

	BinaryFilter(int width, int height, int * filter_data);
	~BinaryFilter();

	int getValue(int x, int y);
	bool erodePixel(TargaImage *img, int x, int y, int c);
	bool dilatePixel(TargaImage *img, int x, int y, int c);
private:
	int pos(int x, int y, int num_col);
};

TargaImage* erode(TargaImage* img, BinaryFilter* filter, int c);
TargaImage* dilate(TargaImage* img, BinaryFilter* filter, int c);
TargaImage* open(TargaImage* img);
TargaImage* close(TargaImage* img);

#endif