/* Justin Fiedler
 * Conversions between multiple colorspaces
 */

#ifndef _COLOR_SPACE_
#define _COLOR_SPACE_

//#include <math.h>
#include <algorithm>
using namespace std;

double ccmin(double x, double y, double z);
double ccmax(double x, double y, double z);

//HSL
void RGBtoHSL(float r, float g, float b, double* h, double* s, double* l);
void HSLtoRGB(double h, double s, double l, float * r, float * g, float * b);
double HueToRGB(double v1, double v2, double vH );

//YCC
void RGBtoYCC(float r, float g, float b, double* y, double* cb, double* cr);
void YCCtoRGB(float y, float cb, float cr, double* r, double* g, double* b);

//Invert RGB
void invertRGB(float r, float g, float b, float* ir, float* ig, float *ib);

#endif