#ifndef _CONVOLUTION_
#define _CONVOLUTION_

#include <math.h>
#include "filters.h"
#include "libtarga.h"
#include "TargaImage.h"

/* filters MUST be of odd width/height */

class ConvolutionFilter{
public:
	int width, height;
	float * filter_data;

	ConvolutionFilter(int width, int height, float * filter_data);
	ConvolutionFilter(float(*filter_function)(float, float), int width=1, int height=1);
	~ConvolutionFilter();

	float getValue(int x, int y);
	void convolutePixel(TargaImage *img, unsigned char * new_pxl, int x, int y);

private:
	int pos(int x, int y, int num_col);
};

TargaImage* convolute(TargaImage* img, ConvolutionFilter* filter);
TargaImage* resample_horz(TargaImage* img, ConvolutionFilter* filter, int new_width);
TargaImage* resample_vert(TargaImage* img, ConvolutionFilter* filter, int new_height);
TargaImage* resample_2D(TargaImage* img, ConvolutionFilter* filter, int new_width, int new_height);
TargaImage* resize(TargaImage* img, ConvolutionFilter* filter, int new_width, int new_height);

#endif