#ifndef _GRAPHICS_
#define _GRAPHICS_

#include <math.h>
#include <stdio.h>
#include <iostream>
using namespace std;
#include "libtarga.h"
#include "TargaImage.h"
#include "filters.h"
#include "colorspace.h"
#include <vector>

//some math constants that math.h wont let me use for some reason
const double PI		= 3.14159265358979323846;
const double PID2	= 1.57079632679489661923;
const float l = 2.0;

//position and pixel funstions
int pos(int x, int y, int num_col);
int c_pos(int x, int y, int rad);
//unsigned char* getPixel(TargaImage* image, int x, int y);
void copy_pxl(unsigned char* src, unsigned char* dest);

//reduce
TargaImage* resize(TargaImage* image, int new_width, int new_height, float(*filter)(float x, float r));
void resample_horz(TargaImage* image, TargaImage* new_image, float(*filter)(float x, float r));
void resample_vert(TargaImage* image, TargaImage* new_image, float(*filter)(float x, float r));

//dithering
void FS_dither_pxl(TargaImage* image, int x, int y, float* d_matrix, int d_size);
TargaImage* bw(TargaImage* image);
TargaImage* greyscale(TargaImage* image);

//impressionist
TargaImage* impress(TargaImage* image, int brush);

//warping
double normalize(int x, int max);
float denormalize(double x, int max);
void warp0_pxl(TargaImage* image, float* x, float* y);
void warp1_pxl(TargaImage* image, float* x, float* y);
void warp2_pxl(TargaImage* image, float* x, float* y);
TargaImage* warp(TargaImage* image, void(*transform)(TargaImage*, float*, float*), int option);
void convolute2d_pxl(TargaImage* image, unsigned char* new_pxl, float x, float y, float(*filter)(float, float), int x_rad, int y_rad);

TargaImage * colorLimit(TargaImage * img);
TargaImage * moveGlow(TargaImage * img1, TargaImage * img2);
TargaImage * blob(TargaImage * img);
TargaImage * HSL(TargaImage * img, bool setH = false, bool setS = false, bool setL = false);
TargaImage * YCC(TargaImage * img);
TargaImage* SnobelEdge(TargaImage * img);
TargaImage* Invert(TargaImage * img);
TargaImage * Cartoonify(TargaImage * img);
TargaImage * specBeGone(TargaImage * img);
TargaImage * BWThreshold(TargaImage * img, float threshhold);
TargaImage * Lichtenstein(TargaImage * img);

#endif